
package net.mcreator.pencilsandsuch.fluid;

import net.minecraftforge.fluids.ForgeFlowingFluid;

import net.minecraft.world.level.material.FluidState;
import net.minecraft.world.level.material.Fluid;
import net.minecraft.world.level.block.state.StateDefinition;
import net.minecraft.world.level.block.LiquidBlock;
import net.minecraft.core.particles.ParticleTypes;
import net.minecraft.core.particles.ParticleOptions;

import net.mcreator.pencilsandsuch.init.PencilsAndSuchModItems;
import net.mcreator.pencilsandsuch.init.PencilsAndSuchModFluids;
import net.mcreator.pencilsandsuch.init.PencilsAndSuchModFluidTypes;
import net.mcreator.pencilsandsuch.init.PencilsAndSuchModBlocks;

public abstract class LiquidRubberFluid extends ForgeFlowingFluid {
	public static final ForgeFlowingFluid.Properties PROPERTIES = new ForgeFlowingFluid.Properties(() -> PencilsAndSuchModFluidTypes.LIQUID_RUBBER_TYPE.get(), () -> PencilsAndSuchModFluids.LIQUID_RUBBER.get(),
			() -> PencilsAndSuchModFluids.FLOWING_LIQUID_RUBBER.get()).explosionResistance(100f).bucket(() -> PencilsAndSuchModItems.LIQUID_RUBBER_BUCKET.get()).block(() -> (LiquidBlock) PencilsAndSuchModBlocks.LIQUID_RUBBER.get());

	private LiquidRubberFluid() {
		super(PROPERTIES);
	}

	@Override
	public ParticleOptions getDripParticle() {
		return ParticleTypes.EFFECT;
	}

	public static class Source extends LiquidRubberFluid {
		public int getAmount(FluidState state) {
			return 8;
		}

		public boolean isSource(FluidState state) {
			return true;
		}
	}

	public static class Flowing extends LiquidRubberFluid {
		protected void createFluidStateDefinition(StateDefinition.Builder<Fluid, FluidState> builder) {
			super.createFluidStateDefinition(builder);
			builder.add(LEVEL);
		}

		public int getAmount(FluidState state) {
			return state.getValue(LEVEL);
		}

		public boolean isSource(FluidState state) {
			return false;
		}
	}
}
